/*
 * AppTaskUart0.c
 *
 *  Created on: 2022222
 *      Author: QiXiang_CHENJIE
 */
#include "AppTaskUart0.h"
#ifdef APP_UART0_ENABLE
static process_Uart0 gProcess_Uart0_Task = PROCESS_UART_STATE_IDLE;
#define PROC_UART0_STATE_SWITCH(a) (gProcess_Uart0_Task = a)
bool uartBattInfoDecode(uint8 *dataPtr);
void Uart0Task(void *pvParameters)
{
	(void)pvParameters;
	UartQueryType Uart0AskMsg;
	uint16 Reg_Num = 0;
	uint16 CRC_chk_buffer = 0;
	uint16 pReadLen = 0;
	UartAnsType UartAnsData;
	while (1)
	{
		switch (gProcess_Uart0_Task)
		{
		case PROCESS_UART_STATE_IDLE:
		{
			vTaskDelay(pdMS_TO_TICKS(10));
			if (TimerCounter % 1000 == 0)
			{
				PROC_UART0_STATE_SWITCH(PROCESS_UART_STATE_READ);
			}
			break;
		}
		case PROCESS_UART_STATE_READ:
		{
			/*ѹݶȡ*/


			/*״̬Ķȡ*/
			Reg_Num = 0x40; //ȡļĴݣݶֿȡ
			Uart0AskMsg.Bms_Address = BMS_ADDRESS_CODE;
			Uart0AskMsg.Bms_Funcode = UART_READ_CODE;
			Uart0AskMsg.Reg_Begin_H = 0x00;
			Uart0AskMsg.Reg_Begin_L = 0x00;
			Uart0AskMsg.Reg_Num_H = Reg_Num >> 8;
			Uart0AskMsg.Reg_Num_L = Reg_Num;
			CRC_chk_buffer = crc_chk((uint8 *)&Uart0AskMsg, 6);
			Uart0AskMsg.CRC_L = CRC_chk_buffer;
			Uart0AskMsg.CRC_H = CRC_chk_buffer >> 8;
			Dio_WriteChannel(DioConf_DioChannel_PTB4_GPIO_OUT_MCU_RS485_EN, STD_ON);
			UART_Send_Data(UART_LPUART0, (uint8 *)&Uart0AskMsg, sizeof(Uart0AskMsg), 1000 * 10);
			Dio_WriteChannel(DioConf_DioChannel_PTB4_GPIO_OUT_MCU_RS485_EN, STD_OFF);
			memset(RX_Buffer[UART_LPUART0], 0x00, sizeof(RX_Buffer[UART_LPUART0]));
			UART_Receive_Data(UART_LPUART0, RX_Buffer[UART_LPUART0], &pReadLen, 1000 * 10);
			Dio_WriteChannel(DioConf_DioChannel_PTB4_GPIO_OUT_MCU_RS485_EN, STD_ON);
			if (pReadLen > 0)
			{
				uint16 CrcChkGet = 0xffff;
				uint16 CrcChkCal = 0x0000;
				memcpy((uint8 *)(&UartAnsData),RX_Buffer[UART_LPUART0],0x03);
				UartAnsData.DataPtr = (uint8 *)(&RX_Buffer[UART_LPUART0][3]);
				CrcChkCal = crc_chk(RX_Buffer[UART_LPUART0], pReadLen-2);
				CrcChkGet = (uint16)((RX_Buffer[UART_LPUART0][pReadLen-1]<<8)|(RX_Buffer[UART_LPUART0][pReadLen-2]));
				if(CrcChkCal==CrcChkGet)
				{
					uartBattInfoDecode(UartAnsData.DataPtr);
				}
			}
			PROC_UART0_STATE_SWITCH(PROCESS_UART_STATE_IDLE);
			break;
		}
		case PROCESS_UART_STATE_SLEEP:
		{
			break;
		}
		default:
			break;
		}
	}
}
bool uartBattInfoDecode(uint8 *dataPtr) //ݴЭȷĽ뺯
{
	uint8 i = 0, temp = 0;
	sint8 BattCurrentNegFlag = 1;
	uint8 TEMP_NUM = 0;
	uint16 Batt_current;
	uint8 BATT_CELL_VOL_NUM = 0, BATT_TEMP_NUM = 0;
	uint32 Battsumvoltage = 0;

	BATT_CELL_VOL_NUM = (dataPtr[(0x00) * 2] << 8) | (dataPtr[(0x00) * 2 + 1]);
	BATT_TEMP_NUM = ((dataPtr[(0x01) * 2] << 8) | (dataPtr[(0x01) * 2 + 1])) - BmsOtherTemp;
	if (BATT_CELL_VOL_NUM != AppDataInfo.BattCellCount || BATT_TEMP_NUM != AppDataInfo.BattTempCount)
	{
		BATT_CELL_VOL_NUM = AppDataInfo.BattCellCount;
		BATT_TEMP_NUM = AppDataInfo.BattTempCount;
	}
	battWorkState = (dataPtr[(0x03 + BATT_CELL_VOL_NUM) * 2 + 1]) & 0x03; //״̬(ԭʼ)0ʾã1ʾŵ磬2ʾ
	Batt_current = (dataPtr[(0x02 + BATT_CELL_VOL_NUM) * 2] << 8) | (dataPtr[(0x02 + BATT_CELL_VOL_NUM) * 2 + 1]);
	//ԭʼݣΪŵΪ
	if (battWorkState == 0x02) //
	{
		if (Batt_current > 0x8000) // Ϊ
		{
			//룬Ϊ
			Batt_current = (uint16)((uint16)(~(Batt_current)) + 1);
			Batt_current = Batt_current / 10;
			BattCurrentNegFlag = -1;
		}
		else
		{
			//Դ룬Ϊ
			Batt_current = Batt_current / 10;
			BattCurrentNegFlag = -1;
		}
	}
	else //ŵ
	{
		if (Batt_current > 0x8000) // Ϊ
		{
			//룬Ϊ
			Batt_current = (uint16)((uint16)(~(Batt_current)) + 1);
			Batt_current = Batt_current / 10;
			BattCurrentNegFlag = 1;
		}
		else
		{
			//Դ룬Ϊ
			Batt_current = Batt_current / 10;
			BattCurrentNegFlag = 1;
		}
	}

	battI = Batt_current * BattCurrentNegFlag + 0x2710;
	// sint16 BattI_Temp = 0;//ѹҪĲ
	// BattI_Temp = Batt_current * BattCurrentNegFlag;
	for (i = 0; i < BATT_CELL_VOL_NUM; i++)
	{
		// battCellU[i] = ((dataPtr[(0x02 + i) * 2] << 8) | dataPtr[(0x02 + i) * 2 + 1]) + (INT16)(cmnm_R_voloffset[i] * BattI_Temp / 10000);//ʹõѹ
		Battsumvoltage = Battsumvoltage + battCellU[i];
	}
	avrgCellVol = Battsumvoltage / BATT_CELL_VOL_NUM;
	TEMP_NUM = BATT_TEMP_NUM + BmsOtherTemp;
//	MOSTemp = dataPtr[(0x06 + BATT_CELL_VOL_NUM + BATT_TEMP_NUM) * 2 + 1];
//	packTemp = dataPtr[(0x06 + BATT_CELL_VOL_NUM + BATT_TEMP_NUM + 1) * 2 + 1];
	// bit0 ~ bit31 represent cell0 ~ cell31
	battBalanceoInfo = dataPtr[(0x06 + BATT_CELL_VOL_NUM + TEMP_NUM) * 2 + 1] | (dataPtr[(0x06 + BATT_CELL_VOL_NUM + TEMP_NUM) * 2] << 8) + (dataPtr[(0x07 + BATT_CELL_VOL_NUM + TEMP_NUM) * 2 + 1] << 16) | (dataPtr[(0x07 + BATT_CELL_VOL_NUM + TEMP_NUM) * 2] << 24);

	// bmsHwVersion = dataPtr[(0x08 + BATT_CELL_VOL_NUM + TEMP_NUM) * 2 + 1];
	// bmsSwVersion = dataPtr[(0x08 + BATT_CELL_VOL_NUM + TEMP_NUM) * 2];

	temp = ((dataPtr[(0x09 + BATT_CELL_VOL_NUM + TEMP_NUM) * 2 + 1]) >> 1) & 0x03;
	battMOSSwitchState = ((temp & 0x01) << 1) | ((temp & 0x02) >> 1);
	battWarningState = (dataPtr[(0x09 + BATT_CELL_VOL_NUM + TEMP_NUM) * 2 + 0] << 16) | (dataPtr[(0x0A + BATT_CELL_VOL_NUM + TEMP_NUM) * 2 + 0] << 8) | (dataPtr[(0x0A + BATT_CELL_VOL_NUM + TEMP_NUM) * 2 + 1]);
	battProtectState = (dataPtr[(0x03 + BATT_CELL_VOL_NUM) * 2 + 0] << 24) | (dataPtr[(0x04 + BATT_CELL_VOL_NUM) * 2 + 0] << 16) | (dataPtr[(0x04 + BATT_CELL_VOL_NUM) * 2 + 1] << 8) | (dataPtr[(0x05 + BATT_CELL_VOL_NUM) * 2 + 1]);
	battSOC = dataPtr[(0x0B + BATT_CELL_VOL_NUM + TEMP_NUM) * 2 + 1];
	battSOH = dataPtr[(0x0C + BATT_CELL_VOL_NUM + TEMP_NUM) * 2 + 1];
	Battdesigncap = (dataPtr[(0x0E + BATT_CELL_VOL_NUM + TEMP_NUM) * 2]) << 24 | (dataPtr[(0x0E + BATT_CELL_VOL_NUM + TEMP_NUM) * 2 + 1]) << 16 | (dataPtr[(0x0F + BATT_CELL_VOL_NUM + TEMP_NUM) * 2]) << 8 | (dataPtr[(0x0F + BATT_CELL_VOL_NUM + TEMP_NUM) * 2 + 1]);
	battPackVol = ((dataPtr[(0x18 + BATT_CELL_VOL_NUM + TEMP_NUM) * 2]) << 8 | (dataPtr[(0x18 + BATT_CELL_VOL_NUM + TEMP_NUM) * 2 + 1])) / 10; // uint 100mV
	maxCellVol = (dataPtr[(0x19 + BATT_CELL_VOL_NUM + TEMP_NUM) * 2] << 8) | dataPtr[(0x19 + BATT_CELL_VOL_NUM + TEMP_NUM) * 2 + 1];
	minCellVol = (dataPtr[(0x1A + BATT_CELL_VOL_NUM + TEMP_NUM) * 2] << 8) | dataPtr[(0x1A + BATT_CELL_VOL_NUM + TEMP_NUM) * 2 + 1];
	battHeatEnableState = dataPtr[(0x1C + BATT_CELL_VOL_NUM + TEMP_NUM) * 2 + 1] & 0x01;

	maxCellTemp = 0x00;
	minCellTemp = 0xFF;
	AvgBattTemp = 0;
	uint16 SumBattTemp = 0;
	for (i = 0; i < BATT_TEMP_NUM; i++)
	{
		SumBattTemp = SumBattTemp + battCellTemp[i];
		maxCellTemp = max(maxCellTemp, battCellTemp[i]);
		minCellTemp = min(minCellTemp, battCellTemp[i]);
	}
	AvgBattTemp = (SumBattTemp - maxCellTemp - minCellTemp) / (BATT_TEMP_NUM - 2);
	return true;
}
#endif
